Contributing Guide
==================

Thank you so much for taking the time to contribute in to htop!

Bug Reports
-----------

Bug reports should be posted in the [Github issue
tracker](https://github.com/htop-dev/htop/issues).
Bug reports are extremely important since it's impossible for us to test
htop in every possible system, distribution and scenario. Your feedback
is what keeps the tool stable and always improving!  Thank you!

Pull Requests
-------------

Code contributions are most welcome! Just [fork the
repo](https://github.com/htop-dev/htop) and send a [pull
request](https://github.com/htop-dev/htop/pulls).  Help is especially
appreciated for support of platforms other than Linux.  If proposing new
features, please be mindful that htop is a system tool that needs to keep a
small footprint and perform well on systems under stress -- so unfortunately
we can't accept every new feature proposed, as we need to keep the tool slim
and maintainable.  Great ideas backed by a PR are always carefully considered
for inclusion though!  Also, PRs containing bug fixes and portability tweaks
are always included, please send those in!

Feature Requests
----------------

Please label Github issues that are feature requests with the [`feature
request`](https://github.com/htop-dev/htop/issues?utf8=%E2%9C%93&q=is%3Aissue+label%3A%22feature+request%22+)
label.

Style Guide
-----------

To make working with the code easier a set of guidelines have evolved in
the past that new contributions should try to follow. While they are not set
in stone and always up for changes should the need arise they still provide
a first orientation to go by when contributing to this repository.

The details of the coding style as well as what to take care about with your
contributions can be found in our [style guide](docs/styleguide.md).
